unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, System.DateUtils,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  VCLTee.TeeSurfa, VclTee.TeeGDIPlus, Vcl.StdCtrls, VCLTee.TeEngine,
  Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart, VCLTee.TeePDFCanvas;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Panel1: TPanel;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Chart1ClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  ZMAX: integer = 5;

procedure TForm1.FormCreate(Sender: TObject);
var
  I, J, Ix: integer;
  aSeries: TColorGridSeries;
  D: double;
  DT: TDateTime;
begin
  DT := Date;
  with Chart1 do begin
    with BottomAxis do SetMinMax(DT, DT+1);
    Axes.Left.Items.Clear;
    for I := 1 to ZMAX do Axes.Left.Items.Add(I,I.ToString);
    with LeftAxis do SetMinMax(0,ZMAX);
  end;
  aSeries := TColorGridSeries.Create(Self);
  with aSeries do begin
    ParentChart := Chart1;
    XValues.DateTime := true;
    IrregularGrid := true;
    Pen.Visible := false;
    PaletteMin := 0;
    PaletteSteps := 20;
    PaletteStep := 1;
    LegendEvery := 1;
    UseColorRange := true;
    UsePalette := true;
    UsePaletteMin := true;
    for J := 0 to 23 do begin
      DT := Date + J*OneHour;
      for I := 0 to ZMAX-1 do begin
        D := Random(20);
        Ix := AddXYZ(DT, D, I);
      end;
    end;
  end;
  Chart1.Align := alClient;
  WindowState := wsMaximized;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  FName: string;
begin
  SaveDialog1.Filter := 'PDF file (*.pdf)|*.pdf';
  FName := Application.Title + '.pdf';
  SaveDialog1.FileName := FName;
  if not SaveDialog1.Execute then Exit;
  FName := SaveDialog1.FileName;
  if ExtractFileExt(FName) = '' then FName := FName + '.pdf';
  try
    TeeSaveToPDFFile(Chart1,FName);
  except
    on E:exception do ShowMessage(E.Message);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I, J, Ix: integer;
  aSeries: TColorGridSeries;
  D: double;
  DT: TDateTime;
begin
  aSeries := TColorGridSeries(Chart1.Series[0]);
  aSeries.Clear;
  DT := Date;
  with Chart1 do begin
    with BottomAxis do SetMinMax(DT, DT+1);
    Axes.Left.Items.Clear;
    for I := 1 to ZMAX do Axes.Left.Items.Add(I,I.ToString);
    with LeftAxis do SetMinMax(0,ZMAX);
  end;
  for J := 0 to 8 do begin
    DT := Date + J*OneHour;
    for I := 0 to ZMAX-1 do begin
      D := Random(20);
      Ix := aSeries.AddXYZ(DT, D, I);
    end;
  end;
  for J := 14 to 23 do begin
    DT := Date + J*OneHour;
    for I := 0 to ZMAX-1 do begin
      D := Random(20);
      Ix := aSeries.AddXYZ(DT, D, I);
    end;
  end;
end;

procedure TForm1.Chart1ClickSeries(Sender: TCustomChart; Series: TChartSeries;
  ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ShowMessage('ValueIndex = ' + ValueIndex.ToString);
end;

end.
